VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsCryptage"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"

' Classe de base cryptage de donnes

Option Explicit

Private mst_FicSrc   As String    ' Fichier source  (d)crypter
Private mst_FicDst   As String    ' fichier destination du (d)cryptage

Private mst_Chaine() As Byte      ' Chane  (d)crypter
Private mlg_Chaine   As Long      ' Longueur de la chane

Private mst_Cle()    As Byte      ' Cl de cryptage
Private mlg_Cle      As Long      ' Taille de la cl de cryptage
Private mst_Erreur   As String    ' Dernier message d'erreur

Public Enum eTypeCryptage
    et_Cryptage = 0
    et_Decryptage = 1
End Enum

Public Enum eModeCryptage
    em_Fichier_Fichier = 0
    em_Fichier_Chaine = 1
    em_Chaine_Fichier = 2
    em_Chaine_Chaine = 3
End Enum

Property Get FichierSource() As String
FichierSource = mst_FicSrc
End Property
Property Let FichierSource(stTmp As String)
mst_FicSrc = stTmp
End Property
Property Get FichierDestination() As String
FichierDestination = mst_FicDst
End Property
Property Let FichierDestination(stTmp As String)
mst_FicDst = stTmp
End Property
Property Get Str() As String
Attribute Str.VB_UserMemId = 0
Attribute Str.VB_MemberFlags = "200"
Dim lgFor As Long
Dim stTmp()
ReDim stTmp(mlg_Chaine)
For lgFor = 0 To mlg_Chaine
    stTmp(lgFor) = Chr$(mst_Chaine(lgFor))
Next lgFor
Str = Join(stTmp, vbNullString)
End Property
Property Let Str(stTmp As String)
Dim lgFor As Long
mlg_Chaine = Len(stTmp) - 1
ReDim mst_Chaine(mlg_Chaine) As Byte
For lgFor = 0 To mlg_Chaine
    mst_Chaine(lgFor) = Asc(Mid$(stTmp, lgFor + 1, 1))
Next lgFor
End Property
Property Get Cle() As String
Dim lgFor As Long
Dim stTmp As String
stTmp = vbNullString
For lgFor = 1 To UBound(mst_Cle)
    stTmp = stTmp & Chr$(mst_Cle(lgFor))
Next lgFor
Cle = stTmp
End Property
Property Let Cle(stTmp As String)
Dim lgFor As Long
mlg_Cle = Len(stTmp)
ReDim mst_Cle(mlg_Cle) As Byte
For lgFor = 1 To mlg_Cle
    mst_Cle(lgFor) = Asc(Mid$(stTmp, lgFor, 1))
Next lgFor
End Property
Property Get Erreur() As String
Erreur = mst_Erreur
End Property

Public Function Cryptage(inTypeCryptage As eTypeCryptage, inModeCryptage As eModeCryptage) As Long
' Crypte ou dcrypte (suivant la valeur de inTypeCryptage)
Dim inFree As Integer
Dim lgFor As Long

If inModeCryptage = em_Fichier_Chaine Or inModeCryptage = em_Fichier_Fichier Then
    If FichierExiste(mst_FicSrc) Then
        mlg_Chaine = FileLen(mst_FicSrc)
        ReDim mst_Chaine(mlg_Chaine) As Byte
        inFree = FreeFile
        Open mst_FicSrc For Binary Access Read As #inFree
        Do While Not EOF(inFree)
            Get #inFree, , mst_Chaine
        Loop
        Close #inFree
        mlg_Chaine = mlg_Chaine - 1
        ReDim Preserve mst_Chaine(mlg_Chaine) As Byte
    Else
        Cryptage = -1
        mst_Erreur = "Fichier source '" & mst_FicSrc & "' introuvable."
        Exit Function
    End If
End If

If inTypeCryptage = et_Cryptage Then Call Crypte Else Call DeCrypte
    
If inModeCryptage = em_Chaine_Fichier Or inModeCryptage = em_Fichier_Fichier Then

    If FichierExiste(mst_FicDst) Then Kill mst_FicDst
    inFree = FreeFile
    Open mst_FicDst For Binary Access Write As #inFree
    For lgFor = 0 To mlg_Chaine
        Put #inFree, lgFor + 1, mst_Chaine(lgFor)
    Next lgFor
    Close #inFree
End If
End Function

Private Sub Crypte()
' Crypte la chane par dfaut de la classe
Dim lgFor As Long
Dim mst_Tmp() As Byte
mst_Tmp() = mst_Chaine()
For lgFor = 0 To mlg_Chaine
    mst_Tmp(lgFor) = mst_Chaine(mlg_Chaine - lgFor) Xor mst_Cle((lgFor Mod mlg_Cle) + 1)
Next lgFor
mst_Chaine = mst_Tmp
End Sub
Private Sub DeCrypte()
' Dcrypte la chane par dfaut de la classe
Dim lgFor As Long
Dim mst_Tmp() As Byte
mst_Tmp() = mst_Chaine()
For lgFor = 0 To mlg_Chaine
    mst_Tmp(mlg_Chaine - lgFor) = mst_Chaine(lgFor) Xor mst_Cle((lgFor Mod mlg_Cle) + 1)
Next lgFor
mst_Chaine = mst_Tmp
End Sub

Private Function FichierExiste(stFichier As String) As Boolean
' Teste l'existence d'un fichier
On Error Resume Next
Err = 0
Call FileLen(stFichier)
FichierExiste = (Err = 0)
End Function

Private Sub Class_Initialize()
' Initialisation de la cl sur 10, 1, 19, 87
' (Cl cyclique pour cryptage plus performant)
ReDim mst_Cle(4) As Byte
mst_Cle(1) = 10
mst_Cle(2) = 1
mst_Cle(3) = 19
mst_Cle(4) = 87
mlg_Cle = 4
End Sub